 # Copyright 2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 # SPDX-License-Identifier: MIT-0
 #
 # Permission is hereby granted, free of charge, to any person obtaining a copy of this
 # software and associated documentation files (the "Software"), to deal in the Software
 # without restriction, including without limitation the rights to use, copy, modify,
 # merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
 # permit persons to whom the Software is furnished to do so.
 #
 # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 # INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 # PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 # HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 # OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 # SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
import json
import gzip
import base64
import boto3
import os

def lambda_handler(event, context):
    kdf = boto3.client('firehose')
    firehoseStream = os.environ['FIREHOSE_TARGET']
    cloudwatchData = event['awslogs']['data']
    decodeCloudwatch = base64.b64decode(cloudwatchData)
    decompressCloudwatch = gzip.decompress(decodeCloudwatch)
    jsonPayload = json.loads(decompressCloudwatch)
    cloudtrailLogs = jsonPayload['logEvents']
    for log_event in cloudtrailLogs:
        logDump = json.dumps(log_event)
        try:
            response = kdf.put_record(DeliveryStreamName=firehoseStream,Record={'Data': logDump})
            print(response)
        except Exception as e:
            print(e)